            z<-function(v,minsize=10)
            {
                v1<-v[!is.na(v) & v!=0]
                if (length(v1)>= minsize)
              {
              z<-mean(v1)/sqrt(var(v1)/(length(v1)))
              }
              if (length(v1)< minsize) z<-0
              return (z)
            }

 #################################################################################
 #                                                                               #
 #                         GEI.TRIMM                                             #
 #                                                                               #
 #################################################################################
GEI.TRIMM <- function(env.file='env.txt',geno.file='pedfile.txt',haplore.file='haplore.ped',
                      hap.file='hap.freq',sampling.num = 1000,n.perm.per.sampling = 1) {
   permu.num1 <- sampling.num
   permu.num2 <- n.perm.per.sampling
   permu.num <- permu.num1 * permu.num2
   read.table(env.file)-> delta.comp
   read.table(geno.file)-> delta
   read.table(haplore.file)-> ped
   read.table(hap.file)-> hap
   #remove rare configuration for computational efficiency
   ped <-ped[ped[,9]>0.0005,]
   dim(delta)[1]/3->ped.num
   dim(delta)[2]/2-3 ->snp.num
###########################
### getting the fine mating type strata
   geno.m <- as.data.frame(hap[ped[,3],4:(3+snp.num)]+hap[ped[,4],4:(3+snp.num)]-2)
   geno.f <- as.data.frame(hap[ped[,5],4:(3+snp.num)]+hap[ped[,6],4:(3+snp.num)]-2 )
   geno.c <- as.data.frame(hap[ped[,7],4:(3+snp.num)]+hap[ped[,8],4:(3+snp.num)]-2)
   m.and.f <- geno.m + geno.f
   ped.geno <-  cbind(ped[,1],m.and.f,ped[,9])
   delta.hap <- as.data.frame(2*geno.c-geno.m-geno.f)
   delta.hap<- delta.hap* ped[,9]
   delta.fill <-NULL
   for ( snp in 1:snp.num) {
    delta.fill<- cbind(delta.fill,f.groupsum(delta.hap[,snp],INDICES=ped[,1], .expand = F)[,1])
    }
    delta <- cbind(delta.comp[,1], delta.fill)
    apply(as.data.frame(delta[,-1]),2,z) ->z.scores

# sample at each permutation based on the configuration probablity
    apply(as.data.frame(ped.geno[,-c(1,dim(ped.geno)[2])]),1,paste,collapse='')->m.and.f
    paste(ped[,1],m.and.f,sep='_')->fam.mf
    f.groupsum(ped[,9],fam.mf)->ped.geno[,dim(ped.geno)[2]] #sum prob of possible config agreeing with the same genotypes
    .dup <-unlist(tapply(fam.mf,ped.geno[,1],duplicated))
    ped.geno[!.dup,]-> ped.geno
    m.and.f <- as.data.frame(m.and.f[!.dup])
    cbind(ped.geno[,1],as.data.frame(m.and.f),ped.geno[,dim(ped.geno)[2]])->hap.set

# keep only families with matches
    unambi.fam <- as.numeric(names(table(hap.set[,1])[table(hap.set[,1])==1]))
    no.match<- names(table(hap.set[,2])[table(hap.set[,2])==1])
    no.match<- hap.set[which(as.character(hap.set[,2])%in%no.match),1]
    no.match<- no.match[no.match%in%unambi.fam]   # contains the id of families with no matches and can be unambiguously identified
# reduce the list to contain only families with matches
    hap.set<- hap.set[!hap.set[,1]%in%c(no.match) ,]
    if (length(no.match>0)) delta <-delta[-c(no.match),]

# .start contains the 0 points for each family ID
    .step <- tapply(hap.set[,1],hap.set[,1],length)
    .start<-cumsum(.step)
    .start<-c(0,.start[-length(.start)])

     delta[,1]-> env
     mean(env) -> env.bar
     env.c<-env-env.bar
     as.data.frame( delta[,-1]) -> ped
     apply(ped*env.c,2,sum) ->gxe.snp

     gxe.perm.r2<-rep(0,permu.num)
     gxe.perm.zmax<-rep(0,permu.num)
     gxe.perm.pp<-rep(0,permu.num)
     gxe.perm.snp <- NULL
     .stop<- FALSE
     m<-0
   while( !.stop& m<permu.num1) {
       m<- m+1
   ############################################
   #  select one triad configuration for each family
      .smp<- tapply(1:dim(hap.set)[1],hap.set[,1],function(x) {
                    if (length(x)==1) .sel <- 1 else  .sel<-sample(1:length(x),1,prob=hap.set[x,3]);return(.sel)})
      .smp <- .start + .smp
      hap.set.r <- hap.set[.smp,]

      # reorder both env and delta matrix so that they are ordered by haplotype set
      .ord <- order(hap.set.r[,2])
      hap.set.r <- hap.set.r[.ord,]
      env.r <- env[.ord]
      ped.r <- as.data.frame(ped[.ord,])
      .step.r <- tapply(hap.set.r[,2],as.numeric(hap.set.r[,2]),length)
      .start.r<-cumsum(.step.r)
      .start.r<-c(0,.start.r[-length(.start.r)])
      .step.r <- cbind(.step.r, .start.r)
       #do multiple permutes for sampling
          for (n in 1:permu.num2) {
           k <- (m-1)*permu.num2 + n
           env.perm<-env.r[unlist(apply(.step.r,1,function(x) {return(sample(1:x[1])+x[2])}))]
           env.perm.c<-env.perm-env.bar
           rbind(gxe.perm.snp,apply(ped.r*env.perm.c,2,sum))-> gxe.perm.snp
          }
       # check if this can be stopped after >100 permutes
      if ((m-1)*permu.num2<100 & m*permu.num2>= 100)  {
          gxe.snp.ck <- gxe.snp-apply(gxe.perm.snp,2,mean)
          scale(gxe.perm.snp, scale=FALSE)->gxe.perm.snp.ck
          gxe.perm.snp.ck<- rbind(gxe.snp.ck, gxe.perm.snp.ck)
          apply(gxe.perm.snp.ck^2,1,sum)->r2.vec
          (t(t(gxe.perm.snp.ck)*z.scores))^2  -> zmax.vec
          apply(zmax.vec,1,max)  ->zmax.vec
          rank(round(r2.vec,10),ties.method='average') ->  rank.r2
          rank(round(zmax.vec,10),ties.method='average')->rank.zmax
          if (rank.r2[1] < 50 & rank.zmax[1]<50) .stop <- TRUE
          }
     }  # end of while loop
    gxe.snp <- gxe.snp-apply(gxe.perm.snp,2,mean)
    scale(gxe.perm.snp, scale=FALSE)->gxe.perm.snp
    gxe.perm.snp<- rbind(gxe.snp, gxe.perm.snp)
    apply(gxe.perm.snp^2,1,sum)->r2.vec
    (t(t(gxe.perm.snp)*z.scores))^2  -> zmax.vec
     apply(zmax.vec,1,max)  ->zmax.vec

    rank(round(r2.vec,10),ties.method='average') ->  rank.r2
    rank(round(zmax.vec,10),ties.method='average')->rank.zmax

    rank.zmax[rank.zmax>rank.zmax[1]]<-rank.zmax[rank.zmax>rank.zmax[1]]-1
    rank.r2[rank.r2>rank.r2[1]]<-rank.r2[rank.r2>rank.r2[1]]-1
    if (rank.zmax[1]==(permu.num+1)) rank.zmax[1]<-permu.num
    if (rank.r2[1]==(permu.num+1)) rank.r2[1]<-permu.num

    p.vec<- -(log((1+permu.num-rank.r2)/permu.num) + log((1+permu.num-rank.zmax)/permu.num))
    rank.p.vec <-rank(p.vec,ties.method='average')
    rank.p.vec[rank.p.vec>rank.p.vec[1]]<-rank.p.vec[rank.p.vec>rank.p.vec[1]]-1
    if (rank.p.vec[1]==(permu.num+1)) rank.p.vec[1]<-permu.num

  cat("P value for GbyE interaction:",(1+permu.num-rank.p.vec[1])/permu.num,"\n")
  }
  
 #############################################################################
 # This following function "f.groupsum" was borrowed from the program Haplin #
 # Thanks to Drs.  H. K. GJESSING and R. T. LIE                              #
 #############################################################################
  f.groupsum<-
function(X, INDICES, .expand = T)
{
	if(length(X) != length(INDICES)) stop("Different lengths of X and INDICES!")

	.l <- length(X)
	.order <- order(INDICES, na.last = T)	# SAVE ORIGINAL ORDERING
	.x <- X[.order]	#
	.indices <- match(INDICES[.order], unique.default(INDICES[.order]))
  	.cumsum <- cumsum(.x)
	.cumsum <- c(.cumsum, .cumsum[.l])
	.first <- c(!duplicated(.indices), T)	# FIRST IN EACH GROUP
	.ind <- (1:.l)[.first[-1]]	# LAST IN EACH GROUP
	.step <- c(.cumsum[.ind][1], diff(.cumsum[.ind]))	# COMPUTE INCREASE IN CUMSUM OVER EACH GROUP
	.sum <- .step[.indices]	# MATCH BACK TO SORTED INDICES
	.sum <- .sum[order(.order)]	# SORT BACK TO ORIGINAL ORDERING
	if(!.expand){
			.nondup <- !duplicated(INDICES)
			.ut <- data.frame(sumx = .sum[.nondup], INDICES = INDICES[.nondup])
			return(.ut)
		}
	return(.sum)
}
#####################################################################################
#setwd("//userdata.niehs.nih.gov/shi2/My Documents/SNP vector/paper/GxE/program/missing")
   GEI.TRIMM(env.file='env.txt',geno.file='pedfile.txt',haplore.file='haplore.ped',
             hap.file='hap.freq',sampling.num = 1000,n.perm.per.sampling = 1)

