 ###############################################################################
 #  This program perform haplotype-environment interaction test when there are #
 #  no missing genotype data                                                   #
 ###############################################################################
         z<-function(v,minsize=10)
 {
     v1<-v[!is.na(v) & v!=0]
     if (length(v1)>= minsize)
   {
   z<-mean(v1)/sqrt(var(v1)/(length(v1)))
  # z2[is.nan(z)]<-0
   }
   if (length(v1)< minsize) z<-0
   return (z)
 }
 
 #################################################################################
 #                                                                               #
 #                         GEI.TRIMM.complete                                    #
 #                                                                               #
 #################################################################################
  GEI.TRIMM.complete <- function(env.file='env.txt',geno.file='pedfile.txt',permu.num=1000) {
  read.table(env.file)-> delta.comp
  read.table(geno.file)-> delta
  geno.m<-delta[seq(1,dim(delta)[1],by=3),seq(7,dim(delta)[2],by=2)]+ delta[seq(1,dim(delta)[1],by=3),seq(8,dim(delta)[2],by=2)] -2
  geno.f<-delta[seq(2,dim(delta)[1],by=3),seq(7,dim(delta)[2],by=2)]+ delta[seq(2,dim(delta)[1],by=3),seq(8,dim(delta)[2],by=2)] -2
  geno.c<-delta[seq(3,dim(delta)[1],by=3),seq(7,dim(delta)[2],by=2)]+ delta[seq(3,dim(delta)[1],by=3),seq(8,dim(delta)[2],by=2)] -2

  delta<-cbind(delta.comp[,1],2*geno.c-geno.m-geno.f)
    dim(delta)[1]->ped.num
    apply(delta[,-1],2,z) ->z.scores

  ###########################
  ### getting the fine mating type strata

 m.and.f <- geno.m + geno.f
apply(m.and.f,1,paste,collapse='')->m.and.f

#mt.uniq contains the group ID's determined by the combination of 4-haplotypes
 mt.uniq<- names(which(table( m.and.f)>1))
#mt.grp contains lists of families in each group
mt.grp<-lapply(mt.uniq,function(x){return (which(as.character(m.and.f)==x))})
new.delta<-NULL
for (l in 1:length(mt.grp)){
 new.delta<-rbind(new.delta,delta[mt.grp[[l]],])
}

.step <- unlist(lapply(mt.grp,length))
.start<-cumsum(.step)
.start<-c(0,.start[-length(.start)])
cbind(.step,.start)-> .step

new.delta[,1]-> env
    mean(env) -> env.bar
      env.c<-env-env.bar
# replace ped with delta matrix so that the previous GxE code can be used directly afterwards
new.delta[,-1] -> ped
apply(ped*env.c,2,sum) ->gxe.snp

  gxe.perm.r2<-rep(0,permu.num)
  gxe.perm.zmax<-rep(0,permu.num)
  gxe.perm.pp<-rep(0,permu.num)
  gxe.perm.snp <- NULL
  for(k in 1:permu.num) {
   env.perm<-env[unlist(apply(.step,1,function(x) {return(sample(1:x[1])+x[2])}))]
   env.perm.c<-env.perm-env.bar
   rbind(gxe.perm.snp,apply(ped*env.perm.c,2,sum))-> gxe.perm.snp
  }
    gxe.snp <- gxe.snp-apply(gxe.perm.snp,2,mean)
    scale(gxe.perm.snp, scale=FALSE)->gxe.perm.snp
    gxe.perm.snp<- rbind(gxe.snp, gxe.perm.snp)
    apply(gxe.perm.snp^2,1,sum)->r2.vec
    (t(t(gxe.perm.snp)*z.scores))^2  -> zmax.vec
     apply(zmax.vec,1,max)  ->zmax.vec

  rank(round(r2.vec,10),ties.method='average') ->  rank.r2
  rank(round(zmax.vec,10),ties.method='average')->rank.zmax

    rank.zmax[rank.zmax>rank.zmax[1]]<-rank.zmax[rank.zmax>rank.zmax[1]]-1
    rank.r2[rank.r2>rank.r2[1]]<-rank.r2[rank.r2>rank.r2[1]]-1

    if (rank.zmax[1]==(permu.num+1)) rank.zmax[1]<-permu.num
    if (rank.r2[1]==(permu.num+1)) rank.r2[1]<-permu.num


    p.vec<- -(log((1+permu.num-rank.r2)/permu.num) + log((1+permu.num-rank.zmax)/permu.num))

    rank.p.vec <-rank(p.vec,ties.method='average')

    rank.p.vec[rank.p.vec>rank.p.vec[1]]<-rank.p.vec[rank.p.vec>rank.p.vec[1]]-1
       if (rank.p.vec[1]==(permu.num+1)) rank.p.vec[1]<-permu.num

  cat("P value for GbyE interaction:",(1+permu.num-rank.p.vec[1])/permu.num,"\n")
}
 #setwd("//userdata.niehs.nih.gov/shi2/My Documents/SNP vector/paper/GxE/program/nomissing")
  GEI.TRIMM.complete(env.file='env.txt',geno.file='pedfile.txt',permu.num=1000)


